clc
close all
clear all
[fil path]=uigetfile([cd '\*.txt']);
D=importdata([path fil],'\t');
LagretilFil=regexp(fil,'\.','split');
LagretilFil=LagretilFil(1,1);
%% Import data and select part of time series
t=D(:,1);
P=D(:,2);
y=D(:,3:size(D,2));
dt=t(2)-t(1);
%% Definerer filter og plotter impuls- og frekvensrespons funksjon
order=8;
cutoff=0.2;
[B,A] = butter(order,cutoff); 
yy=filtfilt(B,A,y);

[H,F] = freqz(B,A,1000,'whole',1/dt);  
[h,ti] = impz(B,A,100,1/dt);

figure('Numbertitle','off','Name', ['Filter properties order=' num2str(order) ' cutoff=' num2str(cutoff)])
subplot(2,1,1)
plot(F(1:round(length(F)/2)),abs(H(1:round(length(F)/2))))
grid on
xlabel('f [hz]')
ylabel('H(f)')
title('Frekvensresponsfunksjon')

subplot(2,1,2)
plot(ti,h)
grid on
xlabel('t [s]')
ylabel('h(t)')
title('Impulsresponsfunksjon')

saveas(gcf,['Used_filter_' LagretilFil{1,1} '.fig'])

%%

figure('units','normalized','outerposition',[0 0 1 1],'Numbertitle','off','Name', 'Filtrerte data og orginale data')
subplot(3,3,1)
plot(t,P)
hold on
ylabel('P(t)')
xlabel('t')
for n=1:size(y,2)
    subplot(3,3,n+1)
    plot(t,y(:,n))
    hold on
    ylabel(['r_' num2str(n) '(t)'])
    xlabel('t')
end

subplot(3,3,1)
plot(t,P)
hold on
ylabel('P(t)')
xlabel('t')
for n=1:size(yy,2)
    subplot(3,3,n+1)
    plot(t,yy(:,n),'--r')
    hold on
    ylabel(['r_' num2str(n) '(t)'])
    xlabel('t')
end

[xcord]=ginput(2);

tmp1=find(t<xcord(1,1)); tmp1=tmp1(length(tmp1),1);
tmp2=find(t>xcord(2,1)); tmp2=tmp2(1,1);

t=t(tmp1:tmp2,:); 
y=detrend(y(tmp1:tmp2,:));
yy=detrend(yy(tmp1:tmp2,:)); 
P=P(tmp1:tmp2,:);

figure('units','normalized','outerposition',[0 0 1 1],'Numbertitle','off','Name', 'Valgte filtrerte data og orginale data')
subplot(3,3,1)
plot(t,P)
ylabel('P(t)')
xlabel('t')
for n=1:size(y,2)
    subplot(3,3,n+1)
    plot(t,y(:,n),'b')
    hold on
    plot(t,yy(:,n),'r')
    
    ylabel(['r_' num2str(n) '(t)'])
    xlabel('t')
end
legend('orginale','Filtrert')

saveas(gcf,['Selected_data_' LagretilFil{1,1} '.fig'])


%% Calculate and plot the FFT of the selected data
for n=1:size(y,2)
    [X(:,n),freq]=positiveFFT(y(:,n)',1/dt,1);
end

figure('units','normalized','outerposition',[0 0 1 1])
for n=1:size(y,2)
    subplot(3,3,n+1)
    plot(freq,abs(X(:,n)))
    hold on
    ylabel(['r_' num2str(n) '(t)'])
    xlabel('f [Hz]')
end


for n=1:size(y,2)
    [X(:,n),freq]=positiveFFT(yy(:,n)',1/dt,1);
end

for n=1:size(y,2)
    subplot(3,3,n+1)
    plot(freq,abs(X(:,n)),'-r')
    hold on
    ylabel(['r_' num2str(n) '(t)'])
    xlabel('f [Hz]')
end

%%
save(['P_Data' LagretilFil{1,1} '.mat'],'t','y','P','yy')
clearvars -except t y P yy